<?php
/**
 * PM Recount
 * Copyright 2013 Starpaul20
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

// Tell MyBB when to run the hooks
$plugins->add_hook("admin_tools_recount_rebuild_start", "pmrecount_do_recount");
$plugins->add_hook("admin_tools_recount_rebuild_output_list", "pmrecount_recount");

// The information that shows up on the plugin manager
function pmrecount_info()
{
	return array(
		"name"				=> "PM Recount",
		"description"		=> "Adds a recount tool that allows you to recount the private message count for each user.",
		"website"			=> "http://galaxiesrealm.com/index.php",
		"author"			=> "Starpaul20",
		"authorsite"		=> "http://galaxiesrealm.com/index.php",
		"version"			=> "1.0",
		"guid"				=> "",
		"compatibility"		=> "16*"
	);
}

// This function runs when the plugin is activated.
function pmrecount_activate()
{
}

// This function runs when the plugin is deactivated.
function pmrecount_deactivate()
{
}

// Actually recount PMs
function pmrecount_do_recount()
{
	global $db, $mybb, $lang;
	$lang->load("pmrecount");

	if($mybb->request_method == "post")
	{
		if(!isset($mybb->input['page']) || intval($mybb->input['page']) < 1)
		{
			$mybb->input['page'] = 1;
		}

		if(isset($mybb->input['do_recountprivatemessages']))
		{
			if($mybb->input['page'] == 1)
			{
				// Log admin action
				log_admin_action("privatemessages");
			}

			if(!intval($mybb->input['privatemessages']))
			{
				$mybb->input['privatemessages'] = 500;
			}

			$query = $db->simple_select("users", "COUNT(uid) as num_users");
			$num_users = $db->fetch_field($query, 'num_users');

			$page = intval($mybb->input['page']);
			$per_page = intval($mybb->input['privatemessages']);
			$start = ($page-1) * $per_page;
			$end = $start + $per_page;

			require_once MYBB_ROOT."inc/functions_user.php";

			$query = $db->simple_select("users", "uid", '', array('order_by' => 'uid', 'order_dir' => 'asc', 'limit_start' => $start, 'limit' => $per_page));
			while($user = $db->fetch_array($query))
			{
				update_pm_count($user['uid']);
			}

			check_proceed($num_users, $end, ++$page, $per_page, "privatemessages", "do_recountprivatemessages", $lang->success_rebuilt_private_messages);
		}
	}
}

// Recount PMs
function pmrecount_recount()
{
	global $db, $mybb, $lang, $form_container, $form;
	$lang->load("pmrecount");

	$form_container->output_cell("<label>{$lang->recount_private_messages}</label><div class=\"description\">{$lang->recount_private_messages_desc}</div>");
	$form_container->output_cell($form->generate_text_box("privatemessages", 500, array('style' => 'width: 150px;')));
	$form_container->output_cell($form->generate_submit_button($lang->go, array("name" => "do_recountprivatemessages")));
	$form_container->construct_row(); 
}

?>